  member('Sample1')
  map
  end

! -- The ShowServerInfo procedure illustrates how to find out what tables and columns are on the server
! -- It does this by using the Tables and Columns methods.
! -- It also shows a crude way to have a generic query result display, (a virtual list box would be better)
! --           by using the GetColumnName method.

ShowServerInfo    procedure()

tablequeue    queue(cwodbctablequeuetype)
              end

columnqueue queue(cwodbccolumnqueuetype)
            end

Window WINDOW('Available tables and columns'),AT(,,535,308),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:ANSI), |
         SYSTEM,GRAY
       LIST,AT(4,8,186,267),USE(?TableList),VSCROLL,FORMAT('51L(2)|M~Database~0L(2)|M57L(2)|M~Table~47L(2)|M~Type~'), |
           FROM(tablequeue)
       LIST,AT(210,8,273,267),USE(?columnlist),VSCROLL,FORMAT('0L(2)|M~Database~0L(2)|M~Owner~0L(2)|M~Table~55L(2)|M~Column~0L(2)|M~nColumnType' &|
           '~61L(2)|M~ColumnType~20L(2)|M~Column Size~'),FROM(columnqueue)
       BUTTON('Query selected table'),AT(44,280,87,14),USE(?QueryButton)
       STRING(''),AT(322,288),USE(?CountString)
     END

i   long
  code
  open(window)
  display
  gsql.tables(TableQueue)
  accept
    case accepted()
    of ?QueryButton
      do GetData
    end
    case event()
    of event:newselection
      case field()
      of ?tablelist
        do showfields
      end
    end
  end

GetData   routine
  data
rqueue    queue
          string(50)
          string(50)
          string(50)
          string(50)
          string(50)
          string(50)
          string(50)
          string(50)
          string(50)
          string(50)
          string(50)
          string(50)
          string(50)
          string(50)
          string(50)
          string(50)
          end

rWindow WINDOW('Query Result'),AT(,,421,267),FONT('MS Sans Serif',8,,FONT:regular),SYSTEM,GRAY,RESIZE
       LIST,AT(4,8,411,253),USE(?List1),HVSCROLL,FORMAT('61L(2)|M61L(2)|M61L(2)|M61L(2)|M61L(2)|M61L(2)|M61L(2)|M61L(2)|M61L(2)|M61L(2)|M' &|
           '61L(2)|M61L(2)|M61L(2)|M61L(2)|M61L(2)|M61L(2)|M'),FROM(rqueue)
      END

i       long
cQuery  cstring(1000)

  code
  get(tablequeue, choice(?tablelist))
  if error()
    exit
  end
  open(rwindow)
  display
  setcursor(cursor:wait)
  if instring(' ', clip(tablequeue.tablename), 1, 1)
    cquery = 'select * from "' & clip(tablequeue.TableName) & '"'
  else
    cquery = 'select * from ' & clip(tablequeue.TableName)
  end
  0{prop:text} = cquery
  gsql.sendquery(cquery)
  gsql.fillqueuewithresult(rqueue)
  setcursor()
  loop i=1 to gsql.getresultcolumncount()
    ?list1{proplist:header, i} = gsql.getcolumnname(i)
  end
  accept
  end
  close(rwindow)


showfields  routine
  get(tablequeue, choice(?tablelist))
  if error()
    exit
  end
  gsql.columns(columnqueue, tablequeue.tablename)

