  member

  include('dynstr.inc'), once

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

sqlreturn     equate(short)
sqlhstmt      equate(long)
sqlusmallint  equate(ushort)
sqlsmallint   equate(short)
sqlpointer    equate(long)
sqlinteger    equate(long)
sqluinteger   equate(ulong)
sqlchar       equate(cstring)
sqlhandle     equate(long)

sqlhdbc       equate(long)
sqlhwnd       equate(long)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


  map
    CreateAccessDatabase(string pDatabaseName, long pversion=0), byte

    module('Odbccp32.dll')
      SQLConfigDataSource(long hwndParent, short fRequest, *cstring lpszDriver, *cstring lpszAttributes), |
        byte, raw, pascal
    end


    module('odbc32')
      SQLGetData(sqlhstmt statementhandle, sqlusmallint columnnumber, sqlsmallint targettype, |
        sqlpointer targetvalueptr, sqlinteger bufferlen, *sqlinteger strlen), sqlreturn, raw, pascal
      SQLDescribeCol(sqlhstmt statementhandle, sqlsmallint columnnumber, *sqlchar columnname, |
        sqlsmallint bufferlen, *sqlsmallint namelengthptr, *sqlsmallint datatypeptr, |
        *sqluinteger columnsizeptr, *sqlsmallint decimaldigitsptr, sqlsmallint nullableptr), sqlreturn, raw, pascal
      SQLNumResultCols(sqlhstmt statementhandle, *sqlsmallint pCols), sqlreturn, raw, pascal
      SQLTables(sqlhstmt StatmentHandle, *sqlchar CatalogName, sqlsmallint NameLength1, |
        *sqlchar SchemaName, sqlsmallint NameLength2, *sqlchar TableName, sqlsmallint NameLength3, |
        *sqlchar TableType, sqlsmallint NameLength4), sqlreturn, raw, pascal
      SQLColumns(sqlhstmt StatmentHandle, *sqlchar CatalogName, sqlsmallint NameLength1, |
        *sqlchar SchemaName, sqlsmallint NameLength2, *sqlchar TableName, sqlsmallint NameLength3, |
        *sqlchar ColumnName, sqlsmallint NameLength4), sqlreturn, raw, pascal
      SQLAllocHandle(sqlsmallint HandleType, sqlhandle InputHandle, *sqlhandle OutputHandlePtr), sqlreturn, raw, pascal
      SQLFetch(sqlhstmt StatementHandle), sqlreturn, raw, pascal
      SQLFreeHandle(sqlsmallint HandleType, sqlhandle Handle), sqlreturn, raw, pascal

      SQLDriverConnect(sqlhdbc EnvHandle, sqlhwnd pWindow, *sqlchar inConnectStr, sqlsmallint Len1, |
        *sqlchar outConnectStr, sqlsmallint bufferlen, *sqlsmallint len2, sqlusmallint drivercompletion), sqlreturn, raw, pascal
      SQLExecDirect(sqlhandle statementhandle, *sqlchar Statement, sqlinteger statementlen), sqlreturn, raw, pascal
      SQLBindCol(sqlhandle statementhandle, sqlusmallint columnnumber, sqlsmallint datatype, sqlpointer dataptr, |
        sqlinteger bufferlen, *long strlen), sqlreturn, raw, pascal
      SQLSetStmtAttr(sqlhandle statementhandle, sqlinteger attribute, sqlpointer valueptr, sqlinteger strlen), |
        sqlreturn, raw, pascal
      SQLGetInfo(sqlhdbc sqlhandle, sqlsmallint pInfoType, sqlpointer pInfoValuePtr, |
        sqlsmallint pBufferLength, *sqlsmallint pStringLenPtr), sqlreturn, raw, pascal
    end
  end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


! --- force some libs to be linked in

_dummyclass1 class, link('odbccp32.lib')
  end

_dummyclass2 class, link('odbc32.lib')
  end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  include('cwodbc.inc'), once

bufferstring    &cstring

m:DefaultFile   &file

m:SilentErrors  byte

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


dllclass  class
destruct  procedure
          end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

CwOdbcClassType   class, type, implements(CwOdbc)
StatementHandle   sqlhstmt
File              &File
Record            &group
LastErrorCode     long
LastError         cstring(100)
LastFileError     cstring(100)
LastFileErrorCode cstring(100)
Construct         procedure()
Destruct          procedure()
Release           procedure()
SetDefaultFile    procedure(*file pFile)
SetFile           procedure(*file pFile)
SetTableInfo      procedure(string pTableName, string pColumnName)
SetTableInfoAuto  procedure(*file pDummyFile)
SendQuery         procedure(string pQuery), byte, proc, virtual
SendQuerySilent   procedure(string pQuery), byte, proc, virtual
Next              procedure(), byte, virtual ! returns 0 if ok, 1 if no more records
GetColumnValue    procedure(long pColumn), string, virtual
GetColumnValueG   procedure(long pColumn)!, string
GetColumnName     procedure(long pColumn), string
GetResultColumnCount  procedure(), long
GetColumnValueByName  procedure(string pColumnName), string
FillQueueWithResult procedure(*queue pQueue)
FillQueueWithResultByName procedure(*queue pQueue)
QueryFromQueue      procedure(*queue pQueue, string pQuery), byte, proc
SqlQuote            procedure(string pStr), string
SqlLike             procedure(string pStr), string
Tables              procedure(*queue pQueue)
Columns             procedure(*queue pQueue, string pTableName)
GetLastErrorString  procedure(), string
GetLastErrorcode      procedure(), long
GetLastFileError      procedure(), string
GetLastFileErrorCode  procedure(), string
GetLastSQL          procedure(), string
SetSilentErrors     procedure(byte pSilent)
GetFileRef          procedure(), *file
CreateAccessDatabase  procedure(string pFileName, long pVersion = 0), byte
GetDBMSName         procedure(), string
                  end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

SqlBuilderClassType class, type, implements(sqlbuilder)
TableQueue    &sqlExpressionQueueType
FieldQueue    &sqlFieldQueueType
JoinQueue     &sqlExpressionQueueType
WhereQueue    &sqlExpressionQueueType
OrderQueue    &sqlExpressionQueueType
HavingQueue   &sqlExpressionQueueType
MakeDistinct  byte
GroupFields   byte
Release       procedure()
Construct     procedure()
Destruct      procedure()
AddTable      procedure(string pTableName) ! can use alias... addtable('customer c')
AddField      procedure(string pExpression, <string pAlias>)
AddAggregate  procedure(string pExpression, <string pAlias>)
AddFunction   procedure(string pExpression, <string pAlias>) ! does NOT get generated into SQL... can be used by GetField later
GetField      procedure(string pAlias), string  ! pAlias is case sensitive.  returns the Expression for the alias.
AddJoin       procedure(string pJoinExpression) ! addjoin('inner join orders on orders.customerid = customers.customerid')
AddWhere      procedure(string pExpression) ! adds to WHERE clause
GroupBy       procedure() ! adds all fields added with Addfield() to GROUP BY
AddOrder      procedure(string pExpression) ! adds to ORDER BY
AddHaving     procedure(string pExpression) ! adds to HAVING
Distinct      procedure() ! adds DISTINCT to SELECT statement generated
Str           procedure(), string ! returns full generated sql statement
ClearAll      procedure()  ! clears entire object, so you can start over and reuse
CleanUpQueue  procedure(*queue pQueue)
              end

sqlFieldQueueType  queue, type
Expression      any
Alias           string(256)
Type            string(1)
                end

sqlExpressionQueueType  queue, type
Expression      any
                end



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!



dllclass.destruct   procedure()
  code
  if not bufferstring &= null
    dispose(bufferstring)
  end


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

sqlQuote  procedure(string pStr)
cstr  cstring(10000)
i     long
rv    any
  code
  loop i=1 to len(clip(pStr))
    if pStr[i] = '<39>'
      cstr = cstr & '<39,39>'
    else
      cstr = cstr & pStr[i]
    end
  end
  return '''' & cstr & ''''


sqlLike   procedure(string pStr)
  code
  return sqlquote(clip(pstr) & '%')


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

newcwodbc   procedure()
c   &cwodbcclasstype
  code
  c &= new CwODBCClassType
  return c.cwOdbc

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

newsqlBuilder procedure()
c &sqlbuilderclasstype
  code
  c &= new sqlbuilderclasstype
  return c.sqlbuilder

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!  Class methods
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

sqlBuilderClassType.Release       procedure()
c &sqlBuilderClassType
  code
  c &= self
  dispose(c)


sqlBuilderClassType.Construct     procedure()
  code
  self.TableQueue &= new sqlExpressionQueueType
  self.FieldQueue &= new sqlFieldQueueType
  self.OrderQueue &= new sqlExpressionQueueType
  self.WhereQueue &= new sqlExpressionQueueType
  self.HavingQueue &= new sqlExpressionQueueType
  self.JoinQueue &= new sqlExpressionQueueType

sqlBuilderClassType.Destruct      procedure
  code
  self.ClearAll()  ! clean up queues (they contain ANY variables)
  dispose(self.TableQueue)
  dispose(self.FieldQueue)
  dispose(self.OrderQueue)
  dispose(self.WhereQueue)
  dispose(self.HavingQueue)
  dispose(self.JoinQueue)


sqlBuilderClassType.CleanUpQueue  procedure(*queue pQueue)
  code
  loop while records(pQueue)
    get(pQueue, 1)
    clear(pQueue)
    delete(pQueue)
  end



sqlBuilderClassType.AddTable      procedure(string pTableName)
  code
  clear(self.tablequeue)
  self.tablequeue.Expression = pTableName
  add(self.tablequeue)

sqlBuilderClassType.AddField      procedure(string pExpression, <string pAlias>)
  code
  clear(self.fieldqueue)
  self.fieldqueue.Expression = pExpression
  self.FieldQueue.Alias = pAlias
  self.FieldQueue.Type = 'C' ! column
  add(self.FieldQueue)

sqlBuilderClassType.AddAggregate  procedure(string pExpression, <string pAlias>)
  code
  clear(self.fieldqueue)
  self.fieldqueue.Expression = pExpression
  self.FieldQueue.Alias = pAlias
  self.FieldQueue.Type = 'A' ! alias
  add(self.FieldQueue)

sqlBuilderClassType.AddFunction   procedure(string pExpression, <string pAlias>)
  code
  clear(self.fieldqueue)
  self.fieldqueue.Expression = pExpression
  self.FieldQueue.Alias = pAlias
  self.FieldQueue.Type = 'F' ! function
  add(self.FieldQueue)

sqlBuilderClassType.GetField      procedure(string pAlias)!, string
  code
  clear(self.fieldqueue)
  self.fieldqueue.Alias = pAlias
  get(self.fieldqueue, self.fieldqueue.Alias)
  if error()
    stop('Alias ' & clip(pAlias) & ' not found for GetField() method.')
    return ''
  end
  return clip(self.fieldqueue.Expression)


sqlBuilderClassType.AddJoin       procedure(string pJoinExpression)
  code
  clear(self.joinqueue)
  self.JoinQueue.Expression = pJoinExpression
  add(self.JoinQueue)

sqlBuilderClassType.AddWhere      procedure(string pExpression)
  code
  clear(self.WhereQueue)
  self.WhereQueue.Expression = pExpression
  add(self.WhereQueue)

sqlBuilderClassType.GroupBy       procedure()
  code
  self.GroupFields = 1

sqlBuilderClassType.AddOrder      procedure(string pExpression)
  code
  clear(self.OrderQueue)
  self.orderqueue.expression = pExpression
  add(self.orderqueue)

sqlBuilderClassType.AddHaving     procedure(string pExpression)
  code
  clear(self.HavingQueue)
  self.havingQueue.Expression = pExpression
  add(self.HavingQueue)

sqlBuilderClassType.Distinct      procedure()
  code
  Self.MakeDistinct = 1

sqlBuilderClassType.Str           procedure()!, string
dstr  &idynstr
rv    any
i     long
hasFlag long
  code
  dstr &= newdynstr()
  dstr.cat('select ')
  if self.MakeDistinct
    dstr.cat('distinct ')
  end
  HasFlag = 0
  loop i=1 to records(self.fieldqueue)
    get(self.fieldqueue, i)
    case upper(self.FieldQueue.Type)
    of 'C' orof 'A'
      if HasFlag
        dstr.cat(', ')
      end
      dstr.cat(self.FieldQueue.Expression)
      if self.FieldQueue.Alias <> ''
        dstr.cat(' as ' & clip(self.FieldQueue.Alias))
      end
      HasFlag = 1
    end
  end
  dstr.cat(' ')
  loop i=1 to records(self.tablequeue)
    get(self.tablequeue, i)
    if i > 1
      dstr.cat(', ')
    else
      dstr.cat('from ')
    end
    dstr.cat(self.tablequeue.Expression)
  end
  dstr.cat(' ')
  loop i=1 to records(self.joinqueue)
    get(self.joinqueue, i)
    dstr.cat(self.joinqueue.expression & ' ')
  end
  loop i=1 to records(self.wherequeue)
    get(self.wherequeue, i)
    if i = 1
      dstr.cat('where')
    else
      dstr.cat('and')
    end
    dstr.cat(' (' & self.WhereQueue.Expression & ') ')
  end
  HasFlag = 0
  if self.GroupFields
    loop i=1 to records(self.FieldQueue)
      get(self.FieldQueue, i)
      if self.fieldqueue.type = 'C' ! column, not aggregate
        if HasFlag = 0
          dstr.cat('group by ')
        else
          dstr.cat(', ')
        end
        dstr.cat(self.fieldqueue.Expression)
        HasFlag = 1
      end
    end
    if HasFlag
      dstr.cat(' ')
    end
  end
  loop i=1 to records(self.orderqueue)
    get(self.orderqueue, i)
    if i = 1
      dstr.cat('order by ')
    else
      dstr.cat(', ')
    end
    dstr.cat(self.orderqueue.expression)
  end
  if records(self.orderqueue)
    dstr.cat(' ')
  end
  loop i=1 to records(self.havingqueue)
    get(self.havingqueue, i)
    if i = 1
      dstr.cat('having')
    else
      dstr.cat('and')
    end
    dstr.cat(' (' & self.HavingQueue.Expression & ') ')
  end
  rv = dstr.str()
  dstr.release()
  return rv


sqlBuilderClassType.ClearAll      procedure()
  code
  self.CleanUpQueue(self.orderqueue)
  self.CleanUpQueue(self.wherequeue)
  self.CleanUpQueue(self.tablequeue)
  self.CleanUpQueue(self.fieldqueue)
  self.CleanUpQueue(self.havingqueue)
  self.CleanUpQueue(self.joinqueue)
  self.MakeDistinct = 0
  self.GroupFields = 0



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

CwOdbcClassType.Construct   procedure
  code
  if not m:defaultfile &= null
    self.setfile(m:defaultfile)
  end
  if bufferstring &= null
    bufferstring &= new(cstring(256))
  end


CwOdbcClasstype.Destruct    procedure
  code


CwOdbcClasstype.GetDBMSName procedure()
hdbc  sqlhandle
lName sqlchar(256)
lStrLen sqlsmallint
rv    sqlreturn
  code
  open(self.file) ! force a connection
  rv = SQLGetInfo(self.file{prop:hdbc}, 17, address(lName), size(lname) - 1, lStrlen)
  if rv = -1
    return ''
  end
  return lName

CwOdbcClasstype.SetSilentErrors procedure(byte pSilent)
  code
  m:SilentErrors = pSilent

CwOdbcClasstype.Release     procedure
c   &cwodbcclasstype
  code
  c &= self
  dispose(c)

cwOdbcClasstype.Columns    procedure(*queue pQueue, string pTableName)
Hand    sqlhandle
inStmt  sqlhstmt
Stmt    sqlhstmt
cat     &sqlchar
len1    sqlsmallint
Schem   &sqlchar
len2    sqlsmallint
Tbl     sqlchar(101)
len3    sqlsmallint
ColName &sqlchar
len4    sqlsmallint
rv      sqlreturn
l       long
i       long
ref     any
  code
  free(pqueue)
  clear(pqueue)
  Tbl = clip(pTableName)
  Len4 = len(Tbl)
  open(self.file)   ! force a connection, even if there are errors
  rv = SqlAllocHandle(3, self.file{prop:hdbc}, Hand)
  rv = sqlcolumns(hand, cat, 0, schem, 0, tbl, len4, ColName, 0)
  loop
    rv = sqlfetch(hand)
    if rv <> 0
      break
    end
    loop i = 1 to 18
      ref &= what(pqueue, i)
      if ref &= null
        break
      end
      rv = sqlgetdata(hand, i, 1, address(bufferstring), size(bufferstring), l)
      ref = bufferstring
    end
    add(pqueue)
  end
  rv = SQLFreeHandle(3, Hand)





cwOdbcClasstype.Tables    procedure(*queue pQueue)
Hand    sqlhandle
inStmt  sqlhstmt
Stmt    sqlhstmt
cat     &sqlchar
len1    sqlsmallint
Schem   &sqlchar
len2    sqlsmallint
Tbl     &sqlchar
len3    sqlsmallint
TblTyp  &sqlchar
len4    sqlsmallint
rv      sqlreturn
l       long
i       long
ref     any
  code
  free(pqueue)
  clear(pqueue)
  open(self.file)   ! force a connection, even if there are errors
  rv = SqlAllocHandle(3, self.file{prop:hdbc}, Hand)
  rv = sqltables(hand, cat, 0, schem, 0, tbl, 0, tbltyp, 0)
  loop
    rv = sqlfetch(hand)
    if rv <> 0
      break
    end
    loop i = 1 to 5
      ref &= what(pqueue, i)
      if ref &= null
        break
      end
      rv = sqlgetdata(hand, i, 1, address(bufferstring), size(bufferstring), l)
      ref = bufferstring
    end
    add(pqueue)
  end
  rv = SQLFreeHandle(3, Hand)


cwOdbcClasstype.SetDefaultFile   procedure(*file pFile)
  code
  m:DefaultFile &= pFile
  self.setfile(pfile)


cwOdbcClasstype.SetFile    procedure(*file pFile)
  code
  self.file &= pFile
  if m:defaultfile &= null
    self.setdefaultfile(pfile)
  end
  self.record &= pfile{prop:record}

cwOdbcClasstype.CreateAccessDatabase    procedure(string pFileName, long pVersion=0)
  code
  return CreateAccessDatabase(pFileName, pVersion)

cwOdbcClasstype.SendQuerySilent   procedure(string pQuery)
sav byte
rv  byte
  code
  sav = m:silenterrors
  m:silenterrors = 1
  rv = self.sendquery(pquery)
  m:silenterrors = sav
  return rv



cwOdbcClasstype.SendQuery   procedure(string pQuery)
rv    byte
  code
  close(self.file)   ! attempt fix case where result column count returns 0 after 1st query
  open(self.file)
  buffer(self.file, 200)
  rv = 0
  self.file{prop:sql} = pQuery
  if error()
    if m:silenterrors = 0
      stop(error() & '<13,10,13,10>' & fileerror() & '<13,10,13,10>' & pQuery)
    end
    rv = 1
  end
  self.statementhandle = self.file{prop:hstmt}
  self.lasterror = error()
  self.lasterrorcode = errorcode()
  self.lastfileerror = fileerror()
  self.lastfileerrorcode = fileerrorcode()
  return rv


cwOdbcClasstype.Next   procedure
  code
  next(self.file)
  if error()
    return 1
  else
    return 0
  end

cwOdbcClassType.GetColumnValue procedure(long pColumn)
ref any
  code
  ref &= what(self.Record, pColumn)
  if ref &= null
    if self.file{prop:fields} = 0
      self.GetColumnValueG(pColumn)
      return bufferstring
    else
      stop('Attempt to get value for column ' & pColumn & ', but file structure doesn''t have that many fields.')
      return ''
    end
  end
  return ref




cwOdbcClasstype.GetColumnValueG   procedure(long pColumn)
l     long
rv    long
tmpstr  &cstring
  code
  bufferstring = ''
  if pColumn > self.GetResultColumnCount()
    if m:silenterrors = 0
      stop('Error: Attempt to get column ' & pColumn & ' when only ' & self.GetResultColumnCount() & ' columns were returned.')
    end
    return ! return a blank string
  end
  rv = sqlgetdata(self.statementhandle, pcolumn, 1, address(bufferstring), size(bufferstring), l)
  if rv = 1  and l > size(bufferstring)  ! buffer too small
    tmpstr &= new cstring(l+1)
    tmpstr = bufferstring ! save the old data
    dispose(bufferstring)
    bufferstring &= new cstring(l+100) 
    ! the following reads the REST of the column's data... not all of it
    rv = sqlgetdata(self.statementhandle, pcolumn, 1, address(bufferstring), size(bufferstring), l)
    bufferstring = tmpstr & bufferstring ! assemble the full data
    dispose(tmpstr)
  end
  if l = -1 ! null value
    bufferstring = ''
  end
  if rv = -1
    bufferstring = ''
  end
  ! BufferString now contains value



cwOdbcClasstype.GetResultColumnCount procedure()
lVal  sqlsmallint
r     long
  code
  r = SqlNumResultCols(self.statementhandle, lVal)
  if r = -1
    return 0
  else
    return lVal
  end


cwOdbcClassType.GetColumnValueByName procedure(string pColumnName)
i   long
  code
  loop i=1 to self.GetResultColumnCount()
    if upper(self.GetColumnName(i)) = upper(pColumnName)
      return self.GetColumnValue(i)
    end
  end
  return '' ! column name not found

cwOdbcClasstype.SetTableInfo    procedure(string pTableName, string pColumnName)
i   long
  code
  self.file{prop:name} = pTableName
  loop i=1 to self.file{prop:fields}
    self.file{prop:name, i} = pColumnName
  end

cwOdbcClassType.SetTableInfoAuto  procedure(*file pDummyFile)
TableQueue  cwodbcTableQueueType
ColumnQueue cwodbcColumnQueuetype
sql         &cwodbc         ! use another instance of this object, with the dummy file, to get table/column info
i           long
InfoSetOkay long
FileAlreadySet  byte
  code
  InfoSetOkay = 0
  if m:DefaultFile &= null
    FileAlreadySet = 0
  else
    FileAlreadySet = 1
  end
  pDummyFile{prop:owner} = self.file{prop:owner}
  sql &= newcwodbc()
  sql.setfile(pDummyFile)
  sql.Tables(TableQueue)
  loop i=1 to records(TableQueue)
    get(TableQueue, i)
    sql.Columns(ColumnQueue, TableQueue.TableName)
    get(ColumnQueue, 1)
    if error()
      cycle ! there must not be any columns visible for the table...
    end
    self.SetTableInfo(TableQueue.TableName, ColumnQueue.ColumnName)
    InfoSetOkay = 1
    break
  end
  if not InfoSetOkay
    stop('Could not automatically set the name of the table and its fields.')
  end
  sql.release()
  if FileAlreadySet = 0 ! we don't want to leave subsequent objects using a bad file structure (the dummy file) by default
    self.setdefaultfile(self.file)
  end




cwOdbcClasstype.SqlLike       procedure(string pStr)
  code
  return sqlLike(pstr)
  

cwOdbcClasstype.SqlQuote      procedure(string pStr)
  code
  return sqlquote(pStr)


cwOdbcClasstype.getcolumnname procedure(long pcolumn)
cbuff cstring(1000)
lBufferLen  sqlsmallint
lNameLenPtr sqlsmallint
lDataTypePtr sqlsmallint
lColumnSizePtr sqluinteger
lDecimalDigitsPtr sqlsmallint
lNullablePtr sqlsmallint
n           long
  code
  cbuff = ''
  lbufferlen = size(cbuff) - 1
  n = sqldescribecol(self.statementhandle, pcolumn, cbuff, lBufferLen, lNameLenptr, lDataTypePtr, |
        lColumnSizePtr, lDecimalDigitsPtr, lNullablePtr)
  if n = -1
    return ''
  end
  return cbuff

cwOdbcClasstype.FillQueueWithResultByName   procedure(*queue pQueue)
i   long
j   long
ref any
refqueue      queue ! use queue to speed things up
FieldRef      any
ColumnNumber  long
              end

  code
  ! first build a reference queue to establish relationship between destination queue and columns in result.
  loop i = 1 to self.getresultcolumncount()
    loop j=1 to 100000
      ref &= what(pqueue, j)
      if ref &= null
        break
      end
      if upper(who(pqueue, j)) = upper(self.getcolumnname(i))
        clear(refqueue)
        refqueue.fieldref &= ref
        refqueue.columnnumber = i
        add(refqueue)
        break
      end
    end
  end
  ! now fill the queue
  free(pqueue)
  clear(pqueue)
  loop while self.next() = 0
    loop i = 1 to records(refqueue)
      get(refqueue, i)
      refqueue.fieldref = self.getcolumnvalue(refqueue.columnnumber)
    end
    add(pqueue)
  end
  get(pqueue, 1) ! make first record current
  ! must clean up the reference queue now because it has ANY field.
  loop while records(refqueue)
    get(refqueue, 1)
    clear(refqueue)
    delete(refqueue)
  end



cwOdbcClasstype.FillQueueWithResult   procedure(*queue pQueue)
i   long
ref any
n   long
  code
  free(pQueue)
  clear(pQueue)
  n = self.GetResultColumnCount()
  loop
    if self.next() <> 0
      break
    end
    loop i=1 to n
      ref &= what(pQueue, i)
      if ref &= null
        break
      end
      ref = self.GetColumnValue(i)
    end
    add(pQueue)
  end
  get(pQueue, 1) ! make first record current


cwOdbcClasstype.QueryFromQueue        procedure(*queue pQueue, string pQuery)
i     long
dstr  &idynstr
ref   any
rv    byte
  code
  rv = 0
  dstr &= newdynstr()
  dstr.cat('select ')
  loop i=1 to 10000
    ref &= what(pQueue, i)
    if ref &= null
      break
    end
    if i > 1
      dstr.cat(', ')
    end
    dstr.cat(who(pQueue, i))
  end
  rv = self.SendQuery(dstr.str() & ' ' & pQuery)
  self.FillQueueWithResult(pQueue)
  dstr.release()
  return rv


cwOdbcClasstype.GetLastErrorString    procedure()!, string
  code
  return self.lasterror



cwOdbcClasstype.GetLastSQL            procedure()!, string
  code
  return self.file{prop:sql}

cwOdbcClasstype.GetLastErrorcode      procedure()!, long
  code
  return self.lasterrorcode

cwOdbcClasstype.GetLastFileError      procedure()!, string
  code
  return self.LastFileError

cwOdbcClasstype.GetLastFileErrorCode  procedure()!, string
  code
  return self.LastFileErrorCode

cwOdbcClasstype.GetFileRef      procedure()
  code
  return self.File





!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!  Interface methods
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

cwOdbcClasstype.cwodbc.FillQueueWithResultByName   procedure(*queue pQueue)
  code
  self.FillQueueWithResultByName(pQueue)

cwOdbcClassType.cwodbc.GetColumnValueByName procedure(string pColumnName)
  code
  return self.GetColumnValueByName(pColumnName)


cwOdbcClasstype.cwodbc.GetResultColumnCount procedure()
  code
  return self.GetResultColumnCount()


cwOdbcClasstype.cwodbc.getcolumnname procedure(long pcolumn)
  code
  return self.GetColumnName(pColumn)


cwOdbcClasstype.cwodbc.release  procedure
  code
  self.release()


cwOdbcClasstype.cwodbc.SetDefaultFile   procedure(*file pFile)
  code
  self.SetDefaultFile(pFile)


cwOdbcClasstype.cwodbc.SetFile    procedure(*file pFile)
  code
  self.SetFile(pFile)


cwOdbcClasstype.cwodbc.CreateAccessDatabase    procedure(string pFileName, long pVersion=0)
  code
  return self.CreateAccessDatabase(pFileName, pVersion)



cwOdbcClasstype.cwodbc.SendQuery   procedure(string pQuery)
  code
  return self.SendQuery(pQuery)


cwOdbcClasstype.cwodbc.Next   procedure
  code
  return self.next()


cwOdbcClasstype.cwodbc.GetColumnValue   procedure(long pColumn)
  code
  return self.GetColumnValue(pColumn)

cwOdbcClasstype.cwodbc.SetTableInfo    procedure(string pTableName, string pColumnName)
  code
  self.SetTableInfo(pTableName, pColumnName)

cwOdbcClassType.cwodbc.SetTableInfoAuto  procedure(*file pDummyFile)
  code
  self.SetTableInfoAuto(pDummyFile)

cwOdbcClasstype.cwodbc.FillQueueWithResult   procedure(*queue pQueue)
  code
  self.FillQueueWithResult(pQueue)

cwOdbcClasstype.cwodbc.QueryFromQueue        procedure(*queue pQueue, string pQuery)
  code
  return self.QueryFromQueue(pQueue, pQuery)

cwOdbcClasstype.cwodbc.SqlQuote      procedure(string pStr)
  code
  return self.SqlQuote(pStr)

cwOdbcClasstype.cwodbc.SqlLike       procedure(string pStr)
  code
  return self.SqlLike(pStr)

cwOdbcClasstype.cwodbc.Tables   procedure(*queue pQueue)
  code
  self.Tables(pQueue)


cwOdbcClasstype.cwodbc.SendQuerySilent   procedure(string pQuery)
  code
  return self.SendQuerySilent(pQuery)


cwOdbcClasstype.cwodbc.Columns    procedure(*queue pQueue, string pTableName)
  code
  self.Columns(pQueue, pTableName)

cwOdbcClasstype.cwodbc.GetDBMSName  procedure()
  code
  return self.GetDBMSName()

cwOdbcClasstype.cwodbc.GetLastErrorString    procedure()!, string
  code
  return self.GetLastErrorString()

cwOdbcClasstype.cwodbc.GetLastSQL            procedure()!, string
  code
  return self.GetLastSQL()


cwOdbcClasstype.cwodbc.SetSilentErrors      procedure(byte pSilent)
  code
  self.SetSilentErrors(pSilent)

cwOdbcClasstype.cwodbc.GetLastErrorcode      procedure()!, long
  code
  return self.GetLastErrorCode()

cwOdbcClasstype.cwodbc.GetLastFileError      procedure()!, string
  code
  return self.GetLastFileError()

cwOdbcClasstype.cwodbc.GetLastFileErrorCode  procedure()!, string
  code
  return self.GetLastFileErrorCode()


cwOdbcClasstype.cwodbc.GetFileRef   procedure()
  code
  return self.GetFileRef()

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

sqlBuilderClassType.sqlBuilder.Release       procedure()
  code
  self.release()

sqlBuilderClassType.sqlBuilder.AddTable      procedure(string pTableName)
  code
  self.addtable(pTablename)

sqlBuilderClassType.sqlBuilder.AddField      procedure(string pExpression, <string pAlias>)
  code
  self.Addfield(pExpression, pAlias)

sqlBuilderClassType.sqlBuilder.AddAggregate  procedure(string pExpression, <string pAlias>)
  code
  self.AddAggregate(pExpression, pAlias)

sqlBuilderClassType.sqlBuilder.AddFunction   procedure(string pExpression, <string pAlias>)
  code
  self.AddFunction(pExpression, pAlias)

sqlBuilderClassType.sqlBuilder.GetField      procedure(string pAlias)!, string
  code
  return self.GetField(pAlias)

sqlBuilderClassType.sqlBuilder.AddJoin       procedure(string pJoinExpression)
  code
  self.AddJoin(pJoinExpression)

sqlBuilderClassType.sqlBuilder.AddWhere      procedure(string pExpression)
  code
  self.AddWhere(pExpression)

sqlBuilderClassType.sqlBuilder.GroupBy       procedure()
  code
  self.GroupBy

sqlBuilderClassType.sqlBuilder.AddOrder      procedure(string pExpression)
  code
  self.AddOrder(pExpression)

sqlBuilderClassType.sqlBuilder.AddHaving     procedure(string pExpression)
  code
  self.AddHaving(pExpression)

sqlBuilderClassType.sqlBuilder.Distinct      procedure()
  code
  self.Distinct()

sqlBuilderClassType.sqlBuilder.Str           procedure()!, string
  code
  return self.Str()

sqlBuilderClassType.sqlBuilder.ClearAll      procedure()
  code
  self.ClearAll()



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


CreateAccessDatabase  procedure(string pDatabaseName, long pVersion=0)
cDriver cstring(256)
cAttrib cstring(256)
cVersion  cstring(10)
  code
  cversion = ''
  case pVersion
  of 2
    cversion = 'V2'
  of 3
    cversion = 'V3'
  of 4
    cversion = 'V4'
  end
  cDriver = 'Microsoft Access Driver (*.mdb)'
  cAttrib = 'CREATE_DB' & cversion & '=' & clip(pDatabaseName) & ' General'
  return sqlconfigdatasource(0, 1, cDriver, cAttrib)




!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! --- notes


!  BOOL SQLConfigDataSource(
!       HWND      hwndParent,
!       WORD      fRequest,
!       LPCSTR      lpszDriver,
!       LPCSTR      lpszAttributes);
!  #define  ODBC_ADD_DSN     1               // Add data source
!  BOOL fCreated;
!  fCreated = SQLConfigDataSource(NULL,
!                          ODBC_ADD_DSN,
!                         "Microsoft Access Driver (*.mdb)",
!                         "CREATE_DB=.\\ATest.mdb General\0" );
!
!  See http://support.microsoft.com/default.aspx?scid=KB;EN-US;q149558&
!  see http://support.microsoft.com/default.aspx?scid=kb;en-us;Q126606 for more things to do with Access through ODBC.
!


